﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.display.Loader;
	import flash.display.SimpleButton;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLLoaderDataFormat;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.ByteArray;
	import flash.utils.Endian;
	import flash.text.TextField;
	import flash.errors.EOFError;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.objects.Cube;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.Collada;
	import org.papervision3d.objects.Failas3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.MaterialsList;
	import org.papervision3d.materials.BitmapFileMaterial;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.core.proto.MaterialObject3D;
	import org.papervision3d.scenes.MovieScene3D;
	
	/*Headeris - 56 B
	4 Teksturos plotis
	4 Teksturos aukstis
	1 Rodyti rodykles (valdymui)
	1 Valdymas pele
	1 Double sided
	1 Smooth
	4 Fono spalva
	4 Wire spalva
	4 FPS
	4 Kameros Z koordinate
	4 Kameros zoom
	4 
	4 3D objekto: X pasukimas
	4  Y pasukimas
	4  Z pasukimas
	4 3D objekto duomenu dydis
	4 Teksturos duomenu dydis
	*/
	
	public class Prog extends Sprite
	{
		private var container: Sprite;
		private var scene: MovieScene3D;
		private var camera: Camera3D;
		private var cube:Cube;
		var mat:MaterialObject3D;
		var matColor:ColorMaterial;
		var matWire:WireframeMaterial;
		var matList:MaterialsList;
		var matBmp:BitmapMaterial;
		var bitmapData:BitmapData;
		var obj:DisplayObject3D;
		var pele_pask:Point;
		var pele:Point;
		var pele_pasp:Boolean;
		
		var headeris:uint = 56;
		var tek_x, tek_y:uint;
		var h_rod,
			h_vald,
			h_double,
			h_smooth:Boolean;
		var h_fonas:uint;
		var h_wire:uint;
		var h_fps:Number;
		var h_kam_z,
			h_kam_zoom:Number;
		var h_pas_x,
			h_pas_y,
			h_pas_z:Number;
		var rod:Array;
		var rod_pasp:Array;

		public function Prog()
		{
			rod = [rod_kairen, rod_desinen, rod_aukstyn, rod_zemyn];
			//Isjungti GUI
			for(var i:int = 0; i < rod.length; i++)
				rod[i].visible = false;
			pele_pask = new Point(0, 0);
			pele = new Point(0, 0);
			pele_pasp = false;
			Uzkrauti();
		}
		
		private function Uzkrauti()
		{
			//Uzkrauti pati save, gauti priklijuotus duomenis
			var loader:URLLoader = new URLLoader();
			var req:URLRequest = new URLRequest(stage.loaderInfo.url);
			loader.dataFormat = URLLoaderDataFormat.BINARY;
			loader.addEventListener(Event.COMPLETE, UzkrautiBaigta);
			loader.addEventListener(IOErrorEvent.IO_ERROR, function(ev:IOErrorEvent){
				//t_klaida.text = "Klaida!";
			});
			try{ loader.load(req); }
			catch(er:Error){
				//t_klaida.text = "Klaida!!";
			}
		}
		
		private function UzkrautiBaigta(ev:Event)
		{
			var dydis:uint;
			var duom:ByteArray;
			var obj_dydis:uint;
			var tek_dydis:uint;
			var obj_duom:ByteArray = new ByteArray();
			var tek_duom:ByteArray = new ByteArray();
			
			//Gaunami parametrai
			dydis = ev.target.bytesTotal;
			duom = ev.target.data;
			duom.endian = Endian.LITTLE_ENDIAN;
			duom.position = dydis - headeris;
			
			//Nuskaitomas headeris
			tek_x = duom.readUnsignedInt();		//t_klaida.text = "tx: " + tek_x;
			tek_y = duom.readUnsignedInt();		//t_klaida.text = "tx: " + tek_x + " ty: " + tek_y;
			h_rod = duom.readBoolean();			//t_klaida.text = "rod: " + h_rod;
			h_vald = duom.readBoolean();		//t_klaida.text = "vald: " + h_vald;
			h_double = duom.readBoolean();
			h_smooth = duom.readBoolean();
			h_fonas = duom.readUnsignedInt();
			h_wire = duom.readUnsignedInt();
			h_fps = duom.readFloat();
			h_kam_z = duom.readFloat();
			h_kam_zoom = duom.readFloat();
			duom.readUnsignedInt();				//Nenaudojamas
			h_pas_x = duom.readFloat();
			h_pas_y = duom.readFloat();
			h_pas_z = duom.readFloat();
			obj_dydis = duom.readUnsignedInt();
			tek_dydis = duom.readUnsignedInt();
			
			//Gaunami objekto, teksturos duomenys
			duom.position = dydis - headeris - tek_dydis - obj_dydis;
			try{ duom.readBytes(obj_duom, 0, obj_dydis); }
			catch(err:EOFError){ /*t_klaida.text = "Klaida!!!";*/ }
			if(tek_dydis > 0){
				duom.position = dydis - headeris - tek_dydis;
				duom.readBytes(tek_duom, 0, tek_dydis);
				tek_duom.position = 0;
			}
			
			
			stage.frameRate = h_fps;
			matWire = new WireframeMaterial(h_wire);
			if(tek_dydis > 0){
				try{
					bitmapData = new BitmapData(tek_x, tek_y);
				}
				catch(err:ArgumentError){
					//t_klaida.text = "Klaida!!!!";
				}
				try{
					bitmapData.setPixels(new Rectangle(0, 0, tek_x, tek_y), tek_duom);
				}
				catch(err:EOFError){
					//t_klaida.text = "Klaida!!!!!";
				}
				catch(err:TypeError){
					//t_klaida.text = "Klaida!!!!!!";
				}
				matBmp = new BitmapMaterial(bitmapData);
				matBmp.doubleSided = h_double;
				matBmp.smooth = h_smooth;
				obj = new Failas3D(obj_duom, matBmp); 
			}
			else{
				obj = new Failas3D(obj_duom, matWire);
			}
			Pradeti();
		}
		
		private function Pradeti()
		{
			//Fonas
			var spr:Sprite = new Sprite();
			spr.graphics.beginFill(h_fonas);
			spr.graphics.drawRect(0, 0, 1600, 1200);
			addChild(spr);
			
			//Objektas
			container = new Sprite;
			container.x = 320;
			container.y = 240;
			addChild(container);
									
			scene = new MovieScene3D( container );
			camera = new Camera3D();
			camera.z = -h_kam_z;
			camera.zoom = h_kam_zoom;
			scene.addChild(obj);
			
			rod_pasp = new Array();
			for(var i:int = 0; i < rod.length; i++){
				if(h_rod){
					rod[i].addEventListener(MouseEvent.MOUSE_DOWN, Rodykle_down);
					rod[i].addEventListener(MouseEvent.MOUSE_UP, Rodykle_up);
					addChild(rod[i]);
					rod[i].visible = true;
				}
				rod_pasp.push(new Boolean(false));
			}
			if(h_vald){
				stage.addEventListener(MouseEvent.MOUSE_DOWN, PeleDown);
				stage.addEventListener(MouseEvent.MOUSE_UP, PeleUp);
				stage.addEventListener(MouseEvent.MOUSE_MOVE, PeleMove);
			}
			stage.addEventListener( Event.ENTER_FRAME, EnterFrame );
		}
		
		private function Rodykle_down(ev:MouseEvent)
		{
			for(var i:int = 0; i < rod.length; i++)
				if(ev.target == rod[i]){
					rod_pasp[i] = true;
				}
		}
		
		private function Rodykle_up(ev:MouseEvent)
		{
			for(var i:int = 0; i < rod.length; i++)
				if(ev.target == rod[i]){
					rod_pasp[i] = false;
				}
		}
		
		private function PeleDown(ev:MouseEvent)
		{
			pele_pask.x = ev.stageX;
			pele_pask.y = ev.stageY;
			pele.x = 0;
			pele.y = 0;
			pele_pasp = true;
		}
		
		private function PeleUp(ev:MouseEvent)
		{
			pele.x = 0;
			pele.y = 0;
			pele_pasp = false;
		}
		
		private function PeleMove(ev:MouseEvent)
		{
			if(pele_pasp){
				pele.x = ev.stageX - pele_pask.x;
				pele.y = ev.stageY - pele_pask.y;
				pele_pask.x = ev.stageX;
				pele_pask.y = ev.stageY;
			}
		}

		private function EnterFrame( event: Event ): void
		{
			if(rod_pasp[3] == true)
				obj.rotationX -= 1.0;
			else if(rod_pasp[2] == true)
				obj.rotationX += 1.0;
			else if(pele_pasp && pele.y != 0)
				obj.rotationX -= pele.y;
			else
				obj.rotationX += h_pas_x;
			
			if(rod_pasp[1] == true)
				obj.rotationY -= 1.0;
			else if(rod_pasp[0] == true)
				obj.rotationY += 1.0;
			else if(pele_pasp && pele.x != 0)
				obj.rotationY -= pele.x;
			else
				obj.rotationY += h_pas_y;
			
			obj.rotationZ += h_pas_z;
			
			scene.renderCamera( camera );
		}
	}
}
