#include <fstream>
#include <iostream>
using namespace std;
#include "tga.hpp"


tgaFailas::tgaFailas(): data(NULL), dat(NULL), x(0), y(0), bpp(0), tipas(0), dataSize(0)
{
}


tgaFailas::~tgaFailas()
{
}


bool tgaFailas::Uzkrauti(const char *pav) throw(const char*)
{
    FILE *failas;
    failas = fopen(pav, "rb");
    if(failas == NULL){
		//throw("Nepavyko atidaryti failo");
        return false;
	}
    fread(header, 1, 18, failas);
    
    tipas = header[2];
    x = header[12] + header[13] * 256;
    y = header[14] + header[15] * 256;
    bpp = header[16];
    
	if(tipas < 2){
		//throw("Netinkamas failo tipas");
		return false;
	}

    dataSize = x * y * (bpp / 8);
    //try{ 
		data = new unsigned char[dataSize];
	//}
	//catch(...){ throw("Neisskirta atmintis!"); }
    fread(data, 1, dataSize, failas);

    fclose(failas);
    
    dat = new unsigned int[x * y];
    if(bpp == 24){
		for(unsigned int i = 0; i < x * y; i++){
			dat[i] = (((data[i*3+0] << 8) + data[i*3+1] << 8) + data[i*3+2] << 8) + 255;
		}
	}
	if(bpp == 32){
		for(unsigned int i = 0; i < x * y; i++){
			dat[i] = ((((data[i*4+0]) << 8) + data[i*4+1] << 8) + data[i*4+2] << 8) + data[i*4+3];
		}
	}
    if(bpp == 8){
		for(unsigned int i = 0; i < x * y; i++){
			dat[i] = (((data[i] << 8) + data[i] << 8) + data[i] << 8) + 255;
		}
	}
	//Apversti
	/*unsigned int cp;
	for(unsigned int i = 0; i < (unsigned int)(x * y / 2); i++){
		cp = dat[i];
		dat[i] = dat[x * y - i - 1];
		dat[x * y - i - 1] = cp;
	}*/
	
	return true;
}


void tgaFailas::Naikinti()
{
    if(data != NULL)
		delete[] data;
	if(dat != NULL)
		delete[] dat;
}


void tgaFailas::Rez()
{
    ofstream fr("rez.txt");
    fr<<x<<" "<<y<<" "<<(int)bpp<<" "<<(int)tipas<<endl;
    for(int i = 0; i < 18; i++)
        fr<<(int)header[i]<<endl;
    fr.close();
}
