//  2008 A-E Software 
// http://ae.gamedev.lt  aab@auto.lt
//
// TGA lib'as, skirtas TGA paveiksliukams skaityti ir rasyti.
// Nepalaikomas RLE suspaudimas, color index
// Modifikuota versija, pritaikyta failo eksportavimui
// i ActionScript.
//
// Pradetas:
//      2007-06-25
// Paskutini karta redaguotas:
//      2008-08-27


/*  TGA headeris (18 baitu)
    0-1     unsigned char       id
    1-2     unsigned char       color map type
    2-3     unsigned char       paveiksliuko tipas
    3-5     short int           colour map first entry
    5-7     short int           colour map length
    7-8     unsigned char       map entry size
    9-10    short int           horizontal origin
    10-12   short int           vertical origin
    12-14   short int           plotis
    14-16   short int           aukstis
    16-17   unsigned char       spalvu gylis
    17-18   unsigned char       image descriptor
*/


#ifndef TGA_HPP
#define TGA_HPP

class tgaFailas{
    public:
    unsigned char   header[18]; //Paveiksliuko headeris
    unsigned char   *data;      //Paveiksliuko duomenys
    unsigned int	*dat;		//Transformuoti duomenys (ARGB)
    unsigned int    x;          //Paveiksliuko plotis
    unsigned int    y;          //Paveiksliuko aukstis
    unsigned char   bpp;        //Bits per Pixel - spalvu gylis
    unsigned char   tipas;      //Paveiksliuko tipas
	unsigned int    dataSize;   //data dalies dydis baitais

    tgaFailas();
    ~tgaFailas();
    bool    Uzkrauti(const char*) throw(const char*);
    void    Naikinti();
    void    Rez();
};

#endif
